summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
author Erik Hanson2010-07-07 09:49:06 +0200
committer Robby Workman2010-07-08 07:13:25 +0200
commit63b183341939c4aff7abd001d5760f22c54cf113 (patch)
tree359c42642fb6bab6a4b09e4c3b77f52740beb2b3
parent3e282ff149f8a4302ab09335f97d31977ccdb210 (diff)
downloadslackbuilds-63b183341939c4aff7abd001d5760f22c54cf113.tar.gz
system/openmpi: Added (an open source MPI-2 implementation)
Signed-off-by: Robby Workman <rworkman@slackbuilds.org>
-rw-r--r--system/openmpi/README3
-rw-r--r--system/openmpi/doinst.sh16
-rw-r--r--system/openmpi/openmpi.SlackBuild100
-rw-r--r--system/openmpi/openmpi.info10
-rw-r--r--system/openmpi/slack-desc19
5 files changed, 148 insertions, 0 deletions
diff --git a/system/openmpi/README b/system/openmpi/README
new file mode 100644
index 0000000000..b51fc987e9
--- /dev/null
+++ b/system/openmpi/README
@@ -0,0 +1,3 @@
+The Open MPI Project is an open source MPI-2 implementation that is
+developed and maintained by a consortium of academic, research, and
+industry partners.
diff --git a/system/openmpi/doinst.sh b/system/openmpi/doinst.sh
new file mode 100644
index 0000000000..11d0b65549
--- /dev/null
+++ b/system/openmpi/doinst.sh
@@ -0,0 +1,16 @@
+config() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ # If there's no config file by that name, mv it over:
+ if [ ! -r $OLD ]; then
+ mv $NEW $OLD
+ elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
+ # toss the redundant copy
+ rm $NEW
+ fi
+ # Otherwise, we leave the .new copy for the admin to consider...
+}
+
+config etc/openmpi-default-hostfile.new
+config etc/openmpi-totalview.tcl.new
+config etc/openmpi-mca-params.conf.new
diff --git a/system/openmpi/openmpi.SlackBuild b/system/openmpi/openmpi.SlackBuild
new file mode 100644
index 0000000000..63247dc15d
--- /dev/null
+++ b/system/openmpi/openmpi.SlackBuild
@@ -0,0 +1,100 @@
+#!/bin/sh
+#
+# Slackware build script for Open MPI
+#
+# Copyright 2010 Erik W. Hanson, Minneapolis, MN, USA
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ''AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=openmpi
+VERSION=1.4.2
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i486 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -eu
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.bz2
+cd $PRGNAM-$VERSION
+chown -R root:root .
+chmod -R u+w,go+r-w,a-s .
+
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+./configure \
+ --prefix=/usr \
+ --sysconfdir=/etc \
+ --localstatedir=/var/lib \
+ --mandir=/usr/man/ \
+ --docdir=/usr/doc/$PRGNAM-$VERSION \
+ --disable-static \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --build=$ARCH-slackware-linux
+
+make
+make install-strip DESTDIR=$PKG
+
+find $PKG/usr/man -type f -exec gzip -9 {} \;
+for i in $(find $PKG/usr/man -type l) ; do ln -s $(readlink $i).gz $i.gz ; rm $i ; done
+
+mv $PKG/etc/openmpi-default-hostfile $PKG/etc/openmpi-default-hostfile.new
+mv $PKG/etc/openmpi-totalview.tcl $PKG/etc/openmpi-totalview.tcl.new
+mv $PKG/etc/openmpi-mca-params.conf $PKG/etc/openmpi-mca-params.conf.new
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a AUTHORS INSTALL LICENSE NEWS README VERSION \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/system/openmpi/openmpi.info b/system/openmpi/openmpi.info
new file mode 100644
index 0000000000..62ef60e3e2
--- /dev/null
+++ b/system/openmpi/openmpi.info
@@ -0,0 +1,10 @@
+PRGNAM="openmpi"
+VERSION="1.4.2"
+HOMEPAGE="http://www.open-mpi.org/"
+DOWNLOAD="http://www.open-mpi.org/software/ompi/v1.4/downloads/openmpi-1.4.2.tar.bz2"
+MD5SUM="53b26fa2586aedaf73cf40effbfcc2f3"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+MAINTAINER="Erik Hanson"
+EMAIL="erik@slackbuilds.org"
+APPROVED="rworkman"
diff --git a/system/openmpi/slack-desc b/system/openmpi/slack-desc
new file mode 100644
index 0000000000..7c793d2504
--- /dev/null
+++ b/system/openmpi/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|'
+# on the right side marks the last column you can put a character in. You must
+# make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':'.
+
+ |-----handy-ruler----------------------------------------------------|
+openmpi: Open MPI (an open source MPI-2 implementation)
+openmpi:
+openmpi: The Open MPI Project is an open source MPI-2 implementation that is
+openmpi: developed and maintained by a consortium of academic, research, and
+openmpi: industry partners.
+openmpi:
+openmpi:
+openmpi:
+openmpi:
+openmpi:
+openmpi: